##################################################
# file: CancelaCFDService_types.py
#
# schema types generated by "ZSI.generate.wsdl2python.WriteServiceModule"
#    /usr/bin/wsdl2py cancela.wsdl
#
##################################################

import ZSI
import ZSI.TCcompound
from ZSI.schema import LocalElementDeclaration, ElementDeclaration, TypeDefinition, GTD, GED

##############################
# targetNamespace
# http://www.w3.org/2000/09/xmldsig#
##############################

class ns1:
    targetNamespace = "http://www.w3.org/2000/09/xmldsig#"

    class SignatureType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "SignatureType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.SignatureType_Def.schema
            TClist = [GTD("http://www.w3.org/2000/09/xmldsig#","SignedInfoType",lazy=False)(pname=(ns,"SignedInfo"), aname="_SignedInfo", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.Base64String(pname=(ns,"SignatureValue"), aname="_SignatureValue", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.w3.org/2000/09/xmldsig#","KeyInfoType",lazy=False)(pname=(ns,"KeyInfo"), aname="_KeyInfo", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.w3.org/2000/09/xmldsig#","ObjectType",lazy=False)(pname=(ns,"Object"), aname="_Object", minOccurs=0, maxOccurs="unbounded", nillable=False, typed=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["Id"] = ZSI.TC.AnyType()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._SignedInfo = None
                    self._SignatureValue = None
                    self._KeyInfo = None
                    self._Object = []
                    return
            Holder.__name__ = "SignatureType_Holder"
            self.pyclass = Holder

    class SignedInfoType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "SignedInfoType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.SignedInfoType_Def.schema
            TClist = [GTD("http://www.w3.org/2000/09/xmldsig#","CanonicalizationMethodType",lazy=False)(pname=(ns,"CanonicalizationMethod"), aname="_CanonicalizationMethod", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.w3.org/2000/09/xmldsig#","SignatureMethodType",lazy=False)(pname=(ns,"SignatureMethod"), aname="_SignatureMethod", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.w3.org/2000/09/xmldsig#","ReferenceType",lazy=False)(pname=(ns,"Reference"), aname="_Reference", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["Id"] = ZSI.TC.AnyType()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._CanonicalizationMethod = None
                    self._SignatureMethod = None
                    self._Reference = None
                    return
            Holder.__name__ = "SignedInfoType_Holder"
            self.pyclass = Holder

    class CanonicalizationMethodType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "CanonicalizationMethodType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.CanonicalizationMethodType_Def.schema
            TClist = [ZSI.TC.AnyElement(aname="_any", minOccurs=0, maxOccurs="unbounded", nillable=False, processContents="strict")]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["Algorithm"] = ZSI.TC.URI()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, mixed=True, mixed_aname="_text", **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._any = []
                    return
            Holder.__name__ = "CanonicalizationMethodType_Holder"
            self.pyclass = Holder

    class SignatureMethodType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "SignatureMethodType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.SignatureMethodType_Def.schema
            TClist = [ZSI.TCnumbers.Iinteger(pname=(ns,"HMACOutputLength"), aname="_HMACOutputLength", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.AnyElement(aname="_any", minOccurs=0, maxOccurs="unbounded", nillable=False, processContents="strict")]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["Algorithm"] = ZSI.TC.URI()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, mixed=True, mixed_aname="_text", **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._HMACOutputLength = None
                    self._any = []
                    return
            Holder.__name__ = "SignatureMethodType_Holder"
            self.pyclass = Holder

    class ReferenceType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "ReferenceType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.ReferenceType_Def.schema
            TClist = [GTD("http://www.w3.org/2000/09/xmldsig#","ArrayOfTransformType",lazy=False)(pname=(ns,"Transforms"), aname="_Transforms", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.w3.org/2000/09/xmldsig#","DigestMethodType",lazy=False)(pname=(ns,"DigestMethod"), aname="_DigestMethod", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.Base64String(pname=(ns,"DigestValue"), aname="_DigestValue", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["Id"] = ZSI.TC.AnyType()
                self.attribute_typecode_dict["URI"] = ZSI.TC.URI()
                self.attribute_typecode_dict["Type"] = ZSI.TC.URI()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._Transforms = None
                    self._DigestMethod = None
                    self._DigestValue = None
                    return
            Holder.__name__ = "ReferenceType_Holder"
            self.pyclass = Holder

    class ArrayOfTransformType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "ArrayOfTransformType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.ArrayOfTransformType_Def.schema
            TClist = [GTD("http://www.w3.org/2000/09/xmldsig#","TransformType",lazy=False)(pname=(ns,"Transform"), aname="_Transform", minOccurs=0, maxOccurs="unbounded", nillable=False, typed=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._Transform = []
                    return
            Holder.__name__ = "ArrayOfTransformType_Holder"
            self.pyclass = Holder

    class TransformType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "TransformType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.TransformType_Def.schema
            TClist = [ZSI.TC.String(pname=(ns,"XPath"), aname="_XPath", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["Algorithm"] = ZSI.TC.URI()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, mixed=True, mixed_aname="_text", **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._XPath = None
                    return
            Holder.__name__ = "TransformType_Holder"
            self.pyclass = Holder

    class DigestMethodType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "DigestMethodType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.DigestMethodType_Def.schema
            TClist = [ZSI.TC.AnyElement(aname="_any", minOccurs=0, maxOccurs="unbounded", nillable=False, processContents="strict")]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["Algorithm"] = ZSI.TC.URI()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, mixed=True, mixed_aname="_text", **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._any = []
                    return
            Holder.__name__ = "DigestMethodType_Holder"
            self.pyclass = Holder

    class KeyInfoType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "KeyInfoType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.KeyInfoType_Def.schema
            TClist = [GTD("http://www.w3.org/2000/09/xmldsig#","X509DataType",lazy=False)(pname=(ns,"X509Data"), aname="_X509Data", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.String(pname=(ns,"KeyName"), aname="_KeyName", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), GTD("http://www.w3.org/2000/09/xmldsig#","KeyValueType",lazy=False)(pname=(ns,"KeyValue"), aname="_KeyValue", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["Id"] = ZSI.TC.AnyType()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, mixed=True, mixed_aname="_text", **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._X509Data = None
                    self._KeyName = None
                    self._KeyValue = None
                    return
            Holder.__name__ = "KeyInfoType_Holder"
            self.pyclass = Holder

    class X509DataType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "X509DataType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.X509DataType_Def.schema
            TClist = [GTD("http://www.w3.org/2000/09/xmldsig#","X509IssuerSerialType",lazy=False)(pname=(ns,"X509IssuerSerial"), aname="_X509IssuerSerial", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.Base64String(pname=(ns,"X509Certificate"), aname="_X509Certificate", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._X509IssuerSerial = None
                    self._X509Certificate = None
                    return
            Holder.__name__ = "X509DataType_Holder"
            self.pyclass = Holder

    class X509IssuerSerialType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "X509IssuerSerialType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.X509IssuerSerialType_Def.schema
            TClist = [ZSI.TC.String(pname=(ns,"X509IssuerName"), aname="_X509IssuerName", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TCnumbers.Iinteger(pname=(ns,"X509SerialNumber"), aname="_X509SerialNumber", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._X509IssuerName = None
                    self._X509SerialNumber = None
                    return
            Holder.__name__ = "X509IssuerSerialType_Holder"
            self.pyclass = Holder

    class KeyValueType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "KeyValueType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.KeyValueType_Def.schema
            TClist = [GTD("http://www.w3.org/2000/09/xmldsig#","RSAKeyValueType",lazy=False)(pname=(ns,"RSAKeyValue"), aname="_RSAKeyValue", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, mixed=True, mixed_aname="_text", **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._RSAKeyValue = None
                    return
            Holder.__name__ = "KeyValueType_Holder"
            self.pyclass = Holder

    class RSAKeyValueType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "RSAKeyValueType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.RSAKeyValueType_Def.schema
            TClist = [ZSI.TC.Base64String(pname=(ns,"Modulus"), aname="_Modulus", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.Base64String(pname=(ns,"Exponent"), aname="_Exponent", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._Modulus = None
                    self._Exponent = None
                    return
            Holder.__name__ = "RSAKeyValueType_Holder"
            self.pyclass = Holder

    class ObjectType_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "ObjectType")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns1.ObjectType_Def.schema
            TClist = [ZSI.TC.AnyElement(aname="_any", minOccurs=0, maxOccurs="unbounded", nillable=False, processContents="strict")]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["Id"] = ZSI.TC.AnyType()
                self.attribute_typecode_dict["MimeType"] = ZSI.TC.String()
                self.attribute_typecode_dict["Encoding"] = ZSI.TC.URI()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, mixed=True, mixed_aname="_text", **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._any = []
                    return
            Holder.__name__ = "ObjectType_Holder"
            self.pyclass = Holder

    class Signature_Dec(ElementDeclaration):
        literal = "Signature"
        schema = "http://www.w3.org/2000/09/xmldsig#"
        substitutionGroup = None
        def __init__(self, **kw):
            kw["pname"] = ("http://www.w3.org/2000/09/xmldsig#","Signature")
            kw["aname"] = "_Signature"
            if ns1.SignatureType_Def not in ns1.Signature_Dec.__bases__:
                bases = list(ns1.Signature_Dec.__bases__)
                bases.insert(0, ns1.SignatureType_Def)
                ns1.Signature_Dec.__bases__ = tuple(bases)

            ns1.SignatureType_Def.__init__(self, **kw)
            if self.pyclass is not None: self.pyclass.__name__ = "Signature_Dec_Holder"

# end class ns1 (tns: http://www.w3.org/2000/09/xmldsig#)

##############################
# targetNamespace
# http://cancelacfd.sat.gob.mx
##############################

class ns2:
    targetNamespace = "http://cancelacfd.sat.gob.mx"

    class Cancelacion_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://cancelacfd.sat.gob.mx"
        type = (schema, "Cancelacion")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns2.Cancelacion_Def.schema
            TClist = [self.__class__.Folios_Dec(minOccurs=0, maxOccurs="unbounded", nillable=False, encoded=kw.get("encoded")), GED("http://www.w3.org/2000/09/xmldsig#","Signature",lazy=False, isref=True)(minOccurs=0, maxOccurs=1, nillable=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["RfcEmisor"] = ZSI.TC.String()
                self.attribute_typecode_dict["Fecha"] = ZSI.TCtimes.gDateTime()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._Folios = []
                    self._Signature = None
                    return
            Holder.__name__ = "Cancelacion_Holder"
            self.pyclass = Holder


        class Folios_Dec(ZSI.TCcompound.ComplexType, LocalElementDeclaration):
            literal = "Folios"
            schema = "http://cancelacfd.sat.gob.mx"
            def __init__(self, **kw):
                ns = ns2.Cancelacion_Def.Folios_Dec.schema
                TClist = [ZSI.TC.String(pname=(ns,"UUID"), aname="_UUID", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
                kw["pname"] = ("http://cancelacfd.sat.gob.mx","Folios")
                kw["aname"] = "_Folios"
                self.attribute_typecode_dict = {}
                ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
                class Holder:
                    typecode = self
                    def __init__(self):
                        # pyclass
                        self._UUID = None
                        return
                Holder.__name__ = "Folios_Holder"
                self.pyclass = Holder




    class Acuse_Def(ZSI.TCcompound.ComplexType, TypeDefinition):
        schema = "http://cancelacfd.sat.gob.mx"
        type = (schema, "Acuse")
        def __init__(self, pname, ofwhat=(), attributes=None, extend=False, restrict=False, **kw):
            ns = ns2.Acuse_Def.schema
            TClist = [self.__class__.Folios_Dec(minOccurs=0, maxOccurs="unbounded", nillable=False, encoded=kw.get("encoded")), GED("http://www.w3.org/2000/09/xmldsig#","Signature",lazy=False, isref=True)(minOccurs=0, maxOccurs=1, nillable=False, encoded=kw.get("encoded"))]
            self.attribute_typecode_dict = attributes or {}
            if extend: TClist += ofwhat
            if restrict: TClist = ofwhat
            else:
                # attribute handling code
                self.attribute_typecode_dict["CodEstatus"] = ZSI.TC.String()
                self.attribute_typecode_dict["Fecha"] = ZSI.TCtimes.gDateTime()
                self.attribute_typecode_dict["RfcEmisor"] = ZSI.TC.String()
            ZSI.TCcompound.ComplexType.__init__(self, None, TClist, pname=pname, inorder=0, **kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._Folios = []
                    self._Signature = None
                    return
            Holder.__name__ = "Acuse_Holder"
            self.pyclass = Holder


        class Folios_Dec(ZSI.TCcompound.ComplexType, LocalElementDeclaration):
            literal = "Folios"
            schema = "http://cancelacfd.sat.gob.mx"
            def __init__(self, **kw):
                ns = ns2.Acuse_Def.Folios_Dec.schema
                TClist = [ZSI.TC.String(pname=(ns,"UUID"), aname="_UUID", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded")), ZSI.TC.String(pname=(ns,"EstatusUUID"), aname="_EstatusUUID", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
                kw["pname"] = ("http://cancelacfd.sat.gob.mx","Folios")
                kw["aname"] = "_Folios"
                self.attribute_typecode_dict = {}
                ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
                class Holder:
                    typecode = self
                    def __init__(self):
                        # pyclass
                        self._UUID = None
                        self._EstatusUUID = None
                        return
                Holder.__name__ = "Folios_Holder"
                self.pyclass = Holder




    class CancelaCFD_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
        literal = "CancelaCFD"
        schema = "http://cancelacfd.sat.gob.mx"
        def __init__(self, **kw):
            ns = ns2.CancelaCFD_Dec.schema
            TClist = [GTD("http://cancelacfd.sat.gob.mx","Cancelacion",lazy=False)(pname=(ns,"Cancelacion"), aname="_Cancelacion", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
            kw["pname"] = ("http://cancelacfd.sat.gob.mx","CancelaCFD")
            kw["aname"] = "_CancelaCFD"
            self.attribute_typecode_dict = {}
            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._Cancelacion = None
                    return
            Holder.__name__ = "CancelaCFD_Holder"
            self.pyclass = Holder

    class CancelaCFDResponse_Dec(ZSI.TCcompound.ComplexType, ElementDeclaration):
        literal = "CancelaCFDResponse"
        schema = "http://cancelacfd.sat.gob.mx"
        def __init__(self, **kw):
            ns = ns2.CancelaCFDResponse_Dec.schema
            TClist = [GTD("http://cancelacfd.sat.gob.mx","Acuse",lazy=False)(pname=(ns,"CancelaCFDResult"), aname="_CancelaCFDResult", minOccurs=0, maxOccurs=1, nillable=False, typed=False, encoded=kw.get("encoded"))]
            kw["pname"] = ("http://cancelacfd.sat.gob.mx","CancelaCFDResponse")
            kw["aname"] = "_CancelaCFDResponse"
            self.attribute_typecode_dict = {}
            ZSI.TCcompound.ComplexType.__init__(self,None,TClist,inorder=0,**kw)
            class Holder:
                typecode = self
                def __init__(self):
                    # pyclass
                    self._CancelaCFDResult = None
                    return
            Holder.__name__ = "CancelaCFDResponse_Holder"
            self.pyclass = Holder

# end class ns2 (tns: http://cancelacfd.sat.gob.mx)

##############################
# targetNamespace
# http://cancelacfd.sat.gob.mx/Imports
##############################

class ns0:
    targetNamespace = "http://cancelacfd.sat.gob.mx/Imports"

# end class ns0 (tns: http://cancelacfd.sat.gob.mx/Imports)
