# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2004-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# $Id: account.py 1005 2005-07-25 08:41:42Z nicoe $
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import fields, osv
import time
from mx.DateTime import *
import tools
import re
import StringIO
from lxml import etree
import base64
import codecs, cfdutil
import os
import httplib
import urllib2
import text
from tools.translate import _

from CancelaCFDService_client import *
from OpenSSL import crypto



#import text

class account_invoice_pay_method(osv.osv):
	_name = 'account.invoice.pay.method'
	_columns = {'name': fields.char('Método de pago', size=64),
		    'description': fields.text('Descripción')}

account_invoice_pay_method()


class account_invoice(osv.osv):
	DEFAULT_PAY_METHOD = "Depósito en cuenta"
	SAT_ENABLED = False  #### Cambiar a True cuando funcione la cancelación directa a la SAT.
	VERSION_2012 = True
	XSINS = 'http://www.w3.org/2001/XMLSchema-instance'
	XSITREE = '{%s}' % XSINS
	XSINSMAP = {'xsi': XSINS}
	schema_location = '{%s}schemaLocation' %(XSINS, )
	V3NS = 'http://www.sat.gob.mx/cfd/3'
	if VERSION_2012:
		V3SCHEMALOCATION = 'http://www.sat.gob.mx/cfd/3 http://www.sat.gob.mx/sitio_internet/cfd/3/cfdv32.xsd http://www.sat.gob.mx/ecc http://www.sat.gob.mx/sitio_internet/cfd/ecc/ecc.xsd'
	else:
		V3SCHEMALOCATION = 'http://www.sat.gob.mx/cfd/3 http://www.sat.gob.mx/sitio_internet/cfd/3/cfdv3.xsd http://www.sat.gob.mx/ecc http://www.sat.gob.mx/sitio_internet/cfd/ecc/ecc.xsd'
	V3TREE = '{%s}' %(V3NS, )
	V3NSMAP = {'cfdi': V3NS}
	V2NS = 'http://www.sat.gob.mx/cfd/2'
	if VERSION_2012:
		V2SCHEMALOCATION = 'http://www.sat.gob.mx/cfd/2 http://www.sat.gob.mx/sitio_internet/cfd/2/cfdv22.xsd http://www.sat.gob.mx/ecc http://www.sat.gob.mx/sitio_internet/cfd/ecc/ecc.xsd'
	else:
		V2SCHEMALOCATION = 'http://www.sat.gob.mx/cfd/2 http://www.sat.gob.mx/sitio_internet/cfd/2/cfdv2.xsd http://www.sat.gob.mx/ecc http://www.sat.gob.mx/sitio_internet/cfd/ecc/ecc.xsd'
	V2TREE = '{%s}' %(V2NS, )
	V2NSMAP = {None: V2NS}
	
	#TRALIXHOST = "pruebastfd.tralix.com"
	TRALIXPORT = 7070
	#TRALIXCUSTOMERKEY = "1c8867c095ef6390829f807888f391b77d72954c"
	_inherit = 'account.invoice'

	def testItem(self, item, tag):
	    if tag in item.tag:
		return True
	    else:
		return False

	_columns= {
		'sign_date':fields.datetime('Sing Date'),
		'cancel_date':fields.datetime('Cancel Date'),
		'certified_date':fields.datetime('Certified Date'),
		'approved_year':fields.integer('Approved Year'),
		'approved_number':fields.integer('Approved Number'),
		'approved_number_sat':fields.char('Approved Number SAT', size=20),
		'certificate': fields.text('Certificate'),
		'digital_signature': fields.text('Signature'),
		'sello_sat': fields.text('Sello SAT'),
		'cadena':fields.text('Cadena'),
		'cadenatimbre': fields.text('Cadena Timbre'),
		'uuid':fields.char('UUID', size=36),
		'bar_code': fields.binary('Bar Code'),
		#'pay_method': fields.selection([('deposito_cuenta', 'Depósito en cuenta'),
		#				('cheque', 'Cheque'),
		#				('efectivo', 'Efectivo'),
		#				('tarjeta_credito', 'Tarjeta de crédito')],
		#			       'Método de pago'),
		'pay_method': fields.many2one('account.invoice.pay.method', 'Método de pago'),
		'pay_account': fields.char('NumCtaPago', size=64),
		'proveedor_cfd': fields.selection([
			('propios_medios', 'Propios Medios'),
			('my_suite_cfd', 'My Suite - CFDI'),
			('my_suite_timbre', 'My Suite - Timbrado'),
			('buzon_fiscal_cfd', 'Buzon Fiscal - CFDI'),
			('buzon_fiscal_timbre', 'Buzon Fiscal - Timbrado'),
			('tralix_timbre', 'Tralix - Timbrado')
			], 'Proveedor CDF', help="""Seleccionar el Proveedor para la generacion del CFD o CFDI.""")
		}


        def invoice_print(self, cr, uid, ids, context=None):
                '''
                This function prints the invoice and mark it as sent, so that we can see more easily the next step of the workflow
                '''
                assert len(ids) == 1, 'This option should only be used for a single id at a time.'
                self.write(cr, uid, ids, {'sent': True}, context=context)
                datas = {
                        'ids': ids,
                        'model': 'account.invoice',
                        'form': self.read(cr, uid, ids[0], context=context)
                        }
                return {
                        'type': 'ir.actions.report.xml',
                        'report_name': 'account.invoice.electronic',
                        'datas': datas,
                        'nodestroy' : True
                        }



	def create(self, cr, uid, vals, context=None):
		my_id = super(account_invoice, self).create(cr, uid, vals, context)
		if not self.VERSION_2012:
			return my_id
		self_brw = self.browse(cr, uid, my_id)
		acct = self_brw.partner_id and self_brw.partner_id.e_invoice_bank_acct
		if acct:
			self.write(cr, uid, my_id, {'pay_account': acct})
		partner_brw = self.pool.get('res.partner').browse(cr, uid, vals['partner_id'])
		method = partner_brw.pay_method and partner_brw.pay_method.id
		if method:
			self.write(cr, uid, my_id, {'pay_method': method})
		return my_id


	def onchange_partner_id(self, cr, uid, ids, type, partner_id,\
				date_invoice=False, payment_term=False, partner_bank_id=False, company_id=False):
		myres = super(account_invoice, self).onchange_partner_id(cr, uid, ids, type, partner_id,
									 date_invoice=date_invoice,
									 payment_term=payment_term,
									 partner_bank_id=partner_bank_id,
									 company_id=company_id)
		if not self.VERSION_2012:
			return myres
		if len(ids):
			self_brw = self.browse(cr, uid, ids[0])
			acct = self_brw.partner_id and self_brw.partner_id.e_invoice_bank_acct
			if acct:
				myres['value'].update(pay_account=acct)
		elif partner_id:
			partner_brw = self.pool.get('res.partner').browse(cr, uid, partner_id)
			acct = partner_brw.e_invoice_bank_acct
			if acct:
				myres['value'].update(pay_account=acct)
		if partner_id:
			partner_brw = self.pool.get('res.partner').browse(cr, uid, partner_id)
			method = partner_brw.pay_method and partner_brw.pay_method.id
			if method:
				myres['value'].update(pay_method=method)
		return myres

	def copy(self, cr, uid, id, default=None, context=None):
		if default is None:
			default = {}
		default = default.copy()
		default.update({'state':'draft', 'number':False, 'move_id':False, 'move_name':False, 'cancel_date':False, 'certified_date':False,
				'approved_year':False, 'approved_number':False, 'certificate':False, 'digital_signature':False, 'date_due':False,
				'date_invoice':False, 'sello_sat':False, 'cadena':False, 'cadenatimbre':False, 'uuid':False, 'bar_code':False, 'period_id':False})
		return super(account_invoice, self).copy(cr, uid, id, default, context)

	def cfdutil_getLineaReporte(self, xml_str_obj, state='False', subtotalstr=None, taxstr=None):
		return cfdutil.getLineaReporte(xml_str_obj, state, subtotalstr, taxstr)

	def cfdutil_verifySello(self, cadena, certfname, sello):
		return cfdutil.verifySello(cadena, certfname, sello)

	def elimante_double_space(self, data):
		data = re.sub('[ \t\n\r\f\v]', ' ',data)
		data = data.strip(' ')
		while '  ' in data:
			data = re.sub('  ', ' ', data)
		return data


	def make_utf(self, data, required=''):
		if not data and required:
			raise osv.except_osv(('Error !'), ('Campo %s es Requerido y esta faltando en la captura.'%(required,)))
		elif data and required:
			
			return self.elimante_double_space(data)
		elif data:
			return self.elimante_double_space(data)
		else:
			return ''

		
	def _period_get(self, cr, uid, ctx={}):
		try:
			ids = self.pool.get('account.period').find(cr, uid, context=ctx)
			return ids[0]
		except:
			return False
		
	def action_cancel(self, cr, uid, ids, *args):
		account_move_obj = self.pool.get('account.move')
		invoices = self.read(cr, uid, ids, ['move_id', 'payment_ids', 'id'])
		for i in invoices:
			inv_brw = self.browse(cr, uid, i['id'])
			if inv_brw.type in ('in_invoice','in_refund'):
				res = super(account_invoice, self).action_cancel(cr, uid, ids, args)
				return True

			if i['payment_ids']:
				account_move_line_obj = self.pool.get('account.move.line')
				pay_ids = account_move_line_obj.browse(cr, uid , i['payment_ids'])
				for move_line in pay_ids:
				    if move_line.reconcile_partial_id and move_line.reconcile_partial_id.line_partial_ids:
					raise osv.except_osv(_('Error !'), _('You cannot cancel the Invoice which is Partially Paid! You need to unreconcile concerned payment entries!'))
			if i['move_id']:
				reconcile_obj = self.pool.get('account.move.reconcile')
				line_obj = self.pool.get('account.move.line')
				move_obj = self.pool.get('account.move')
				date = time.strftime('%Y-%m-%d')
				period = self._period_get(cr, uid)
				#inv_brw = self.browse(cr, uid, i['id'])
				if inv_brw.state in ['draft', 'proforma2', 'cancel']:
					raise  osv.except_osv(_('Error !'), _('Can not cancel draft/proforma/cancel invoice.'))
				if inv_brw.type == 'in_invoice':
					description = 'Fac. '+inv_brw.reference+' Cancelada'
				elif inv_brw.type == 'out_invoice':
					description = 'Fac. '+inv_brw.number+' Cancelada'
				else:
					description = 'Fac. '+inv_brw.number+' Cancelada'
				if not period:
					raise  osv.except_osv(_('Data Insufficient !'), _('No Period found on Invoice!'))
				move_id = move_obj.copy(cr, uid, inv_brw.move_id.id, context={}, default={'date':date, 'period_id':period, 'ref':description })
				move = move_obj.browse(cr, uid, move_id)
				move_obj.write(cr, uid, [move_id], {'date':date, 'name':inv_brw.move_id.name + '-C'})
				for line in move.line_id:
					line_obj.write(cr, uid, [line.id], {
						'debit': line.credit,
						'credit': line.debit,
						'amount_currency': line.amount_currency and -line.amount_currency or False,
						'date':date,
						#'name':move.name + '-C',
						}, context={'multireconcile':True})

				    #move_obj.post(self, cr, uid, [move_id])
				move_obj.post(cr, uid, [move_id])
				#if inv is paid we unreconcile
                                movelines = inv_brw.move_id.line_id
                                #we unreconcile the lines
                                to_reconcile_ids = {}
                                for line in movelines :
                                    #if the account of the line is the as the one in the invoice
                                    #we reconcile
                                    if line.account_id.id == inv_brw.account_id.id :
                                        to_reconcile_ids[line.account_id.id] =[line.id]
                                    if type(line.reconcile_id) != osv.orm.browse_null :
                                        reconcile_obj.unlink(cr,uid, line.reconcile_id.id)

                                #we match the line to reconcile
                                for tmpline in move.line_id :
                                    if tmpline.account_id.id == inv_brw.account_id.id :
                                        to_reconcile_ids[tmpline.account_id.id].append(tmpline.id)
                                for account in to_reconcile_ids :
                                    line_obj.reconcile(cr, uid, to_reconcile_ids[account],
                                        type = 'simple',
                                        writeoff_period_id=period,
                                        writeoff_journal_id=inv_brw.journal_id.id,
                                        writeoff_acc_id=inv_brw.account_id.id
                                    )
                                date_time = now().Format('%Y-%m-%d %H:%M:%S')
                                self.write(cr, uid, inv_brw.id, {'cancel_date':date_time, 'state':'cancel'})
                                #Original
                                #account_move_obj.button_cancel(cr, uid, [i['move_id'][0]])
                                # delete the move this invoice was pointing to
                                # Note that the corresponding move_lines and move_reconciles
                                # will be automatically deleted too
                                #account_move_obj.unlink(cr, uid, [i['move_id'][0]])


                                self.write(cr, uid, ids, {'state':'cancel'})
                                self._log_event(cr, uid, ids,-1.0, 'Cancel Invoice')
                                date_time = now().Format('%Y-%m-%d %H:%M:%S')
                                self.write(cr, uid, ids, {'cancel_date':date_time})
			if inv_brw.company_id.proveedor_cfd == 'my_suite_cfd' and inv_brw.journal_id.e_invoice:
				from  invoice_mys import *
				self.mysuiteConn = MySuiteConn()
				self.mysuiteConn.transaction = "CANCEL_XML"
				self.get_MysuiteConn(cr, uid, inv_brw)
				try:
					number = int(inv_brw.number)
				except ValueError:
					sequence_type = 'account.invoice.factura_e'
					cr.execute("SELECT prefix from ir_sequence where code ='%s'"%(sequence_type))
					prefix = cr.fetchone()
					if prefix:
						prefix = prefix[0]
						self.mysuiteConn.data1 = prefix
					number = int(inv_brw.number.strip(prefix))
				#number, prefix = self.get_inv_number(cr, uid, inv_brw)
				self.mysuiteConn.data2 = number
				data1, data2, data3 = self.make_Mysuite_Transaction(cr, uid)
			elif inv_brw.company_id.proveedor_cfd == 'tralix_timbre' and inv_brw.journal_id.e_invoice:
				if inv_brw.state == 'draft':
					return super(account_invoice, self).action_cancel(cr, uid, ids, args)
				if self.SAT_ENABLED:
					cancelacion = ns2.Cancelacion_Def('Cancelacion')
					folio = ns2.Cancelacion_Def.Folios_Dec()
					folio._UUID = inv_brw.uuid
					cancelacion._Folios = (folio, )
					mydate = inv_brw.certified_date
					agnio = int(mydate[:4])
					mes = int(mydate[5:7])
					dia = int(mydate[8:10])
					hora = int(mydate[11:13])
					minuto = int(mydate[14:16])
					seg = int(mydate[17:19])
					cancelacion._attrs = {'Fecha': (agnio, mes, dia, hora, minuto, seg, 0),
							      'RfcEmisor': inv_brw.company_id.partner_id.vat}
					sign = ns1.SignatureType_Def('_Signature')
					cancelacion._Signature = sign
					siginfo = ns1.SignedInfoType_Def('_SignedInfo')
					sign._SignedInfo = siginfo
					canmethod = ns1.CanonicalizationMethodType_Def('_CanonicalizationMethod')
					siginfo._CanonicalizationMethod = canmethod
					canmethod._attrs = {'Algorithm': inv_brw.company_id.tralix_canonicalization_method}
					sigmethod = ns1.SignatureMethodType_Def('_SignatureMethod')
					siginfo._SignatureMethod = sigmethod
					sigmethod._attrs = {'Algorithm': inv_brw.company_id.tralix_signature_method}
					ref = ns1.ReferenceType_Def('_Reference')
					siginfo._Reference = ref
					trarray = ns1.ArrayOfTransformType_Def('_Transforms')
					ref._Transforms = trarray
					tr = ns1.TransformType_Def('_Transform')
					trarray._Transform = (tr, )
					tr._attrs = {'Algorithm': inv_brw.company_id.tralix_transform}
					dm = ns1.DigestMethodType_Def('_DigestMethod')
					ref._DigestMethod = dm
					dm._attrs = {'Algorithm': inv_brw.company_id.tralix_digest_method}
					#ref._DigestValue = 'japxj0Fk8pwWgWBA/4P/MMKKj3k='
					#sign._SignatureValue = '''ekoAJRgEfUo4h8g3GBNJDvA7UmBuqntu3Rl1o7rLuiCvLUPxOL77In2MBX4XLqyfcW5UfK+N9mp3
					#VE5wolXmiIhlgwK92SLzXFLZJxSAqr4ma+um6Es3XEjSyoI3OqKTRFZh54CZSPMIEXFuTmssDzvU
					#cYzDlok3PFMEA6dtpR4='''
					keyinf = ns1.KeyInfoType_Def('_KeyInfo')
					sign._KeyInfo = keyinf
					xdata = ns1.X509DataType_Def('_X509Data')
					keyinf._X509Data = xdata
					xserial = ns1.X509IssuerSerialType_Def('_X509IssuerSerial')
					xdata._X509IssuerSerial = xserial
					mycert = crypto.load_certificate(crypto.FILETYPE_ASN1, base64.b64decode(inv_brw.company_id.certificate.datas))
					xserial._X509SerialNumber = mycert.get_serial_number()
					cc = mycert.get_issuer().get_components()
					issuer = ', '.join([('='.join([unicode(x[0], 'utf-8'), unicode(x[1], 'utf-8')])) for x in cc])
					xserial._X509IssuerName = issuer
					url = CancelaCFDServiceLocator().getBasicHttpBinding_ICancelaCFDBindingAddress()
					url = "https://cancelacion.facturaelectronica.sat.gob.mx/Cancelacion/CancelaCFDService.svc"
					client = BasicHttpBinding_ICancelaCFDBindingSOAP(url)
					client.binding.AddHeader('CUSTOMERKEY', inv_brw.company_id.tralix_customer_key)
					req = ICancelaCFDBinding_CancelaCFD_InputMessage()
					req._Cancelacion = cancelacion
					resp = client.CancelaCFD(req)
					result = resp._CancelaCFDResult
					if result._attrs['CodEstatus'] != '200':
						raise osv.except_osv(_('Error !'),
								     "Respuesta servicio Tralix: Status: %s" %(result._attrs['CodEstatus'], ))
						return False

		return True





				
	def action_cancel_draft(self, cr, uid, ids, *args):
		for inv_brw in self.browse(cr, uid, ids):
			if inv_brw.journal_id.e_invoice:
				raise osv.except_osv(('Warrnig !'), ('This electronic invoice can not be set to draft.'))
			else:
				super(account_invoice, self).action_cancel_draft( cr, uid, ids, *args)
		






	def undo_action_number(self, cr, uid, inv_brw , *args):
		number = inv_brw.number

		if not number:
			if (inv_brw.journal_id.e_invoice) and (inv_brw.journal_id.type == 'sale_refund'):
				invtype = 'nota_credito_e'
			elif inv_brw.journal_id.e_invoice:
				invtype = 'factura_e'
			cr.execute('lock table ir_sequence')
			cr.execute("select id,number_next,number_increment,prefix,suffix,padding from ir_sequence where code = 'account.invoice." + invtype + "' and active=True")
			res = cr.dictfetchone()
			if res:
				cr.execute('update ir_sequence set number_next=number_next-number_increment where id=%s and active=True', (res['id'],))
				cr.commit()
		return True

	def test_open(self, cr, uid, ids, *args):
		for inv_brw in self.browse(cr, uid, ids):
			super(account_invoice, self).action_date_assign( cr, uid, ids, *args)
			super(account_invoice, self).action_move_create( cr, uid, ids, *args)
			if inv_brw.type in ('in_invoice','in_refund'):
				#super(account_invoice, self).action_number( cr, uid, ids, *args)
				##actualizacion
				self.action_number( cr, uid, ids, *args)
			#super(account_invoice, self).action_number( cr, uid, ids, *args)
			#else:
				#print '	super(account_invoice'
				#super(account_invoice, self).action_number( cr, uid, [inv_brw.id], *args)
			if (inv_brw.journal_id.e_invoice) and (inv_brw.type in ('out_invoice', 'out_refund')):
				#try:
				self.action_number( cr, uid, [inv_brw.id], *args)
				if inv_brw.company_id.proveedor_cfd == 'propios_medios':
					cfe, cfe_tree = self.create_xml(cr, uid, [inv_brw.id], *args)
					self.put_addenda(cr, uid, inv_brw, cfe, cfe_tree)
					self.write(cr, uid, inv_brw.id, {'sign_date':cfe.get('fecha'),
									 'approved_year':cfe.get('anoAprobacion') and int(cfe.get('anoAprobacion')),
									 'approved_number':cfe.get('noAprobacion') and int(cfe.get('noAprobacion')),
									 'certificate':cfe.get('certificado'),
									 'digital_signature': self.sello,
									 'cadena': self.cadena,
									 'date_invoice': cfe.get('fecha').split('T')[0],
									 'proveedor_cfd': inv_brw.company_id.proveedor_cfd})
				elif inv_brw.company_id.proveedor_cfd == 'my_suite_cfd':
					cadenatimbre = ''
					from  invoice_mys import *
					self.mysuiteConn = MySuiteConn()
					self.mysuiteConn.transaction = "CONVERT_NATIVE_XML"
					self.get_MysuiteConn(cr, uid, inv_brw)
					cfe, cfe_tree = self.create_xml(cr, uid, [inv_brw.id], *args)
					cfe_str = etree.tostring(cfe, pretty_print=True, encoding='utf-8', xml_declaration=True)
					my_suite_dir = self.get_my_suite_dir(cr, uid, inv_brw)
					#from  invoice_mys import create_mysuite_xml
					cfe_mysuite_req = create_mysuite_xml(cfe_str, my_suite_dir)
					date_time = now().Format('%Y_%m_%d%H_%M_%S')
					self.mysuiteConn.data1 = "/tmp/Factura_mysuite_%s.txt"%(date_time)
					#self.mysuiteConn.data1 = "/tmp/Factura_mysuite.txt"
					open(self.mysuiteConn.data1,'w').write(cfe_mysuite_req)
					self.mysuiteConn.data2 = "XML"
					data1, data2, data3 = self.make_Mysuite_Transaction(cr, uid)
					#### Aqui se pondria self.put_addenda... Falta verificar con MySuite
				elif inv_brw.company_id.proveedor_cfd == 'tralix_timbre':
					cfe, cfe_tree = self.create_xml(cr, uid, [inv_brw.id], *args)
					tfd = self.getTimbreTralix(cr, uid, cfe, inv_brw.company_id.id)
					cadenatimbre = cfdutil.getCadenaTimbre(tfd)
					complemento = etree.SubElement(cfe, cfe_tree+"Complemento")
					complemento.append(tfd)
					self.put_addenda(cr, uid, inv_brw, cfe, cfe_tree)
					sello_sat = tfd.get("selloSAT")
					certified_date = tfd.get("FechaTimbrado")
					uuid = tfd.get("UUID")
					approved_number_sat = tfd.get("noCertificadoSAT")
				if inv_brw.company_id.proveedor_cfd == 'tralix_timbre':
					self.write(cr, uid, inv_brw.id, {'sign_date':cfe.get('fecha'),
									 'approved_year':cfe.get('anoAprobacion') and int(cfe.get('anoAprobacion')),
									 'approved_number':cfe.get('noAprobacion') and int(cfe.get('noAprobacion')),
									 'certificate':cfe.get('certificado'),
									 'digital_signature': self.sello,
									 'cadena': self.cadena,
									 'cadenatimbre': cadenatimbre,
									 'date_invoice': cfe.get('fecha').split('T')[0],
									 'uuid': uuid,
									 'certified_date': certified_date,
									 'sello_sat': sello_sat,
									 'approved_number_sat': approved_number_sat,
									 'proveedor_cfd': inv_brw.company_id.proveedor_cfd})
					self.make_barcode(cr, uid, inv_brw.id)
				cfe_str = etree.tostring(cfe, pretty_print=True, encoding='utf-8', xml_declaration=True)
				self.attach_xml(cr, uid, inv_brw.id, cfe_str)
				#except:
					#self.undo_action_number( cr, uid, inv_brw , *args)
					#raise osv.except_osv(('Error !'), ('Error al crear la Factura.'))
			else:
				#super(account_invoice, self).action_number( cr, uid, [inv_brw.id], *args)
				#actualizacoin
				self.action_number( cr, uid, [inv_brw.id], *args)
		return True

	def attach_xml(self, cr, uid, id, cfe):
		inv_brw = self.browse(cr, uid, id)
		file_ids = self.pool.get('document.directory').search(cr, uid, [('company_id','=',inv_brw.company_id.id)])
		file_ids.sort()
		if not file_ids:
			raise osv.except_osv(('Error !'), ('No directory for this company, please create one first'))
		self.pool.get('ir.attachment').create(cr, uid, {
			'name': 'Fact.-' + inv_brw.number,
			'datas': base64.encodestring(cfe),
			'datas_fname': inv_brw.number + '.xml',
			'res_model': self._name,
			'res_id': inv_brw.id,
			'company_id': inv_brw.company_id.id,
			'parent_id': file_ids[0],
			}, )
		return True



	def make_barcode(self, cr, uid, inv_id):
		inv_brw = self.browse(cr, uid, inv_id)
		try:
			bar_code_res = cfdutil.createBarCodeImg(inv_brw.company_id.partner_id.vat,
								inv_brw.partner_id.vat,
								inv_brw.amount_total,
								inv_brw.uuid,
								'/tmp/%s.png'%(inv_brw.uuid,))
		except:
			bar_code_res = -1

		if bar_code_res == 0:
	                fid = open('/tmp/%s.png'%(inv_brw.uuid,),'r')
			bar_code = fid.read()
			self.write(cr, uid, inv_id, {
				'bar_code':base64.encodestring(bar_code)})
			
		return True


		
	def get_my_suite_dir(self, cr, uid, inv_brw):
		res = {'CdgPaisEmisor': 'MX',
		       'CdgPaisReceptor': 'MX',
		       'Usuario':'MX.MAD970910UF5.DISTRIBUCION',
		       'Moneda':'MXN',
		       'tipoDeCambio':'1',
		       'TotalEnLetra':text.text(int(inv_brw.amount_total)) + ' ' + str('%.2f'%inv_brw.amount_total)[-2:] + '/100' + 'MXN',
		       'sucursal':"Centro",
		       'impuestos_conceptos':self.compute_tax_by_line(cr, uid, inv_brw.id)}
		return res
	
	def get_MysuiteConn(self, cr, uid,  inv_brw):
		self.mysuiteConn.entity = inv_brw.company_id.entity
		self.mysuiteConn.requestor = inv_brw.company_id.requestor
		self.mysuiteConn.user = inv_brw.company_id.user_mysuite
		self.mysuiteConn.username = inv_brw.company_id.username_mysuite
		return True


	def mysuiteClassPath(self, cr, uid):
		path = "/home/josepato/erp/addons_all/bias_trunk/bias_electronic_invoice"
		var = "for item in $(ls %s/axis2/*.jar); do export CLASSPATH=${CLASSPATH}:$item; done"%path
		os.popen(var)
		
	def mysuite_update_invoice(self, cr, uid, xml, inv_brw):
		cfe = etree.parse(StringIO.StringIO(xml))
		cfdroot = cfe.getroot()
		folio = cfdroot.get('folio')
		serie = cfdroot.get('serie')
		anoAprobacion = cfdroot.get('anoAprobacion')
		noAprobacion = cfdroot.get('noAprobacion')
		sign_date = cfdroot.get('fecha')
		certificado = cfdroot.get('certificado')
		sello = cfdroot.get('sello')
		cadenatimbre = ''
		for item in cfdroot.iterchildren():
			if self.testItem(item, "Addenda"):
			    addenda = item
			    for fx in addenda.iterchildren():
				    if self.testItem(fx, "FactDocMX"):
					    fxRoot = fx
					    for fxChild in fxRoot.iterchildren():
						    if self.testItem(fxChild, "Identificacion"):
							    identificacion = fxChild
							    for identChild in identificacion.iterchildren():
								    if self.testItem(identChild, "CadenaOriginal"):
									    cadenaOriginal = identChild
			if self.testItem(item, "Complemento"):
				complemento = item
				for cc in complemento.iterchildren():
					if self.testItem(cc, "TimbreFiscalDigital"):
						cadenatimbre = cfdutil.getCadenaTimbre(cc)
						sello_sat = cc.get("selloSAT")
						certified_date = cc.get("FechaTimbrado")
						uuid = cc.get("UUID")
						approved_number_sat = cc.get("noCertificadoSAT")
						
		cadena = cadenaOriginal.text
		if serie:
			number = serie + folio
		else:
			number = folio
		
		res = self.write(cr, uid, inv_brw.id, {
			'approved_year':anoAprobacion,
			'approved_number':noAprobacion,
			'certificate':certificado,
			'digital_signature':sello,
			'sign_date':sign_date,
			'number':number,
			'cadena':cadena,
			'cadenatimbre': cadenatimbre,
			'uuid':uuid,
			'certified_date':certified_date,
			'sello_sat':sello_sat,
			'approved_number_sat':approved_number_sat,
			'proveedor_cfd': inv_brw.company_id.proveedor_cfd})

		self.make_barcode(cr, uid, inv_brw.id)
		cfe_str = etree.tostring(cfe, pretty_print=True, encoding='utf-8', xml_declaration=True)
		return cfe_str


					     
				    
	def make_Mysuite_Transaction(self, cr, uid):
		self.mysuiteClassPath(cr, uid)
		data1 = ''
		data2 = ''
		data3 = ''
		comunication_result = ''
		comunication_hint = ''
		comunication_data = ''
		base64data = ''
		base64data2 = ''
		base64data3 = ''
		execute = 'java MySuiteClient --requestor="%s" --transaction="%s" --country="%s" --entity="%s" --user="%s" --username="%s" --data1="%s" --data2="%s" --data3="%s" 2>/dev/null' %(self.mysuiteConn.requestor, self.mysuiteConn.transaction, self.mysuiteConn.country, self.mysuiteConn.entity, self.mysuiteConn.user, self.mysuiteConn.username, self.mysuiteConn.data1, self.mysuiteConn.data2, self.mysuiteConn.data3)
		fid = os.popen('java MySuiteClient --requestor="%s" --transaction="%s" --country="%s" --entity="%s" --user="%s" --username="%s" --data1="%s" --data2="%s" --data3="%s"' %(self.mysuiteConn.requestor, self.mysuiteConn.transaction, self.mysuiteConn.country, self.mysuiteConn.entity, self.mysuiteConn.user, self.mysuiteConn.username, self.mysuiteConn.data1, self.mysuiteConn.data2, self.mysuiteConn.data3))
		resp = fid.readlines()
		fid.close()
		base64data = ""
		xml = ""
		comunication_msg = 0
		for linea in resp:
			if linea.find("Resultado ") == 0:
				comunication_result = linea[10:-2]
				
			if linea.find("Hint:") == 0:
				comunication_hint = linea[6:]
				
			if comunication_msg == 1:
				comunication_data += linea
				
			if linea.find("Data:") == 0:
				comunication_data = linea[6:]
				comunication_msg = 1
				
			if linea.find("Descripción:") == 0:
				comunication_msg = 0	

				
			if linea.find("Data1: ") == 0:
				base64data = linea[7:]
			if linea.find("Data2: ") == 0:
				base64data2 = linea[7:]
			if linea.find("Data3: ") == 0:
				base64data3 = linea[7:]
		if comunication_result == "ERRONEO":
			raise osv.except_osv(('Error !'), ('Error de comunicacion.\n %s, %s'%(comunication_hint, comunication_data)))

		if base64data:
			fid = os.popen('echo "%s" | base64 -d' %(base64data, ))
			data1 = fid.read()
			fid.close()
		if base64data2:
			fid = os.popen('echo "%s" | base64 -d' %(base64data, ))
			data2 = fid.read()
			fid.close()
		if base64data3:
			fid = os.popen('echo "%s" | base64 -d' %(base64data, ))
			data3 = fid.read()
			fid.close()
		return data1, data2, data3


	def getTimbreTralix(self, cr, uid, objroot, company_id):
		NS = "http://schemas.xmlsoap.org/soap/envelope/"
		TREE = "{%s}" % NS
		NSMAP = {"soapenv": NS}
		soapobj = etree.Element(TREE + "Envelope", nsmap=NSMAP)
		header = etree.SubElement(soapobj, TREE + "Header")
		body = etree.SubElement(soapobj, TREE + "Body")
		body.append(objroot)
		tralix_custormer_key , tralix_host = self.pool.get('res.company').getTralixVariables(cr, uid, company_id)
		sendstr = etree.tostring(soapobj, pretty_print=True, encoding="utf-8", xml_declaration=True)
		conn = httplib.HTTPSConnection(tralix_host, self.TRALIXPORT)
		conn.connect()
		conn.putrequest('POST', '/')
		conn.putheader("Content-Type", "text/xml;charset=UTF-8")
		conn.putheader("SOAPAction", '"urn:TimbradoCFD"')
		conn.putheader("CustomerKey", tralix_custormer_key)
		conn.putheader("User-Agent", "OpenBias OpenERP client")
		conn.putheader("Content-Length", str(len(sendstr)))
		conn.endheaders()
		conn.send(sendstr)
		resp = conn.getresponse()
		respobj = etree.parse(resp)
		envelope = respobj.getroot()
		body = envelope.getchildren()[0]
		if not "body" in body.tag.lower():
			raise osv.except_osv ("Error", "Error en cuerpo de respuesta.")
		child = body.getchildren()[0]
		if "fault" in child.tag.lower():
			detail = child.getchildren()[0]
			error = detail.getchildren()[0]
			codigo = error.attrib["codigo"]
			desc = error.getchildren()[0].text
			raise osv.except_osv("Error %s" %(codigo, ), desc)
		else:
			return child


	def set_cfe_defaults_v3(self):
		mynsmap = dict(self.XSINSMAP)
		mynsmap.update(self.V3NSMAP)
		cfe = etree.Element(self.V3TREE+'Comprobante', nsmap=mynsmap, attrib={self.schema_location: self.V3SCHEMALOCATION})
		if self.VERSION_2012:
			cfe.set('version', '3.2')
		else:
			cfe.set('version', '3.0')
		return cfe
		#NS = 'http://www.w3.org/2001/XMLSchema-instance'
		#TREE = '{%s}' % NS
		#NSMAP = {'xsi': NS}
		#schema_location = '{%s}schemaLocation' % NS
		#cfe = etree.Element('Comprobante', attrib={schema_location:"http://www.sat.gob.mx/cfd/3 http://www.sat.gob.mx/sitio_internet/cfd/3/cfdv3.xsd http://www.sat.gob.mx/ecc http://www.sat.gob.mx/sitio_internet/cfd/ecc/ecc.xsd"})
		#cfe.set('xmlns',"http://www.sat.gob.mx/cfd/3")
		#cfe.set('version','3.0')
		#return cfe

	def set_cfe_defaults(self):
		mynsmap = dict(self.XSINSMAP)
		mynsmap.update(self.V2NSMAP)
		cfe = etree.Element(self.V2TREE+'Comprobante', nsmap=mynsmap, attrib={self.schema_location: self.V2SCHEMALOCATION})
		if self.VERSION_2012:
			cfe.set('version', '2.2')
		else:
			cfe.set('version', '2.0')
		return cfe
		#NS='http://www.w3.org/2001/XMLSchema-instance'
		#TREE = '{%s}' % NS
		#NSMAP = {'xsi': NS}
		#schema_location = '{%s}schemaLocation' % NS
		#cfe = etree.Element('Comprobante', attrib={schema_location:"http://www.sat.gob.mx/cfd/2 http://www.sat.gob.mx/sitio_internet/cfd/2/cfdv2.xsd http://www.sat.gob.mx/ecc http://www.sat.gob.mx/sitio_internet/cfd/ecc/ecc.xsd"})
		#cfe.set('xmlns',"http://www.sat.gob.mx/cfd/2")
		#cfe.set('version','2.0')
		#return cfe

	def create_xml(self,cr, uid, ids, context={}):
		for inv_brw in self.browse(cr, uid, ids):
			if inv_brw.company_id.proveedor_cfd in ('my_suite_timbre', 'buzon_fiscal_timbre', 'tralix_timbre'):
				cfe_tree = self.V3TREE
				cfe = self.set_cfe_defaults_v3()
				cfe = self.get_datos_comprobante_v3(cr, uid, inv_brw, cfe, context)
			else:
				cfe_tree = self.V2TREE
				cfe = self.set_cfe_defaults()
				cfe = self.get_datos_comprobante(cr, uid, inv_brw, cfe, context)
			emisor = self.get_emisor(cr, uid, inv_brw, cfe_tree)
			receptor = self.get_receptor(cr, uid, inv_brw, cfe_tree)
			conceptos = self.get_conceptos(cr, uid, inv_brw.invoice_line, cfe_tree)
			impuestos = self.get_impuestos(cr, uid, inv_brw.tax_line, cfe_tree)
			#certificado = self.get_certificado(cr, uid, inv_brw)
			cfe.append(emisor)
			cfe.append(receptor)
			cfe.append(conceptos)
			cfe.append(impuestos)
			if inv_brw.company_id.proveedor_cfd in ('propios_medios', 'my_suite_timbre', 'buzon_fiscal_timbre', 'tralix_timbre'):
				self.cadena = cfdutil.getCadenaOriginal(cfe)

				#keyfname = os.path.join(tools.config['root_path'], 'filestore/%s/%s'%(cr.dbname, inv_brw.company_id.key.store_fname))

				#sello = cfdutil.getSello(cadena, keyfname, inv_brw.company_id.key_phrase)

				sello = cfdutil.getSelloSHA1(self.cadena, inv_brw.company_id.ruta_key, inv_brw.company_id.key_phrase)
				if not sello:
					raise osv.except_osv(('Error !'), ('Error al crear el sello.'))
				else:
					self.sello = sello
				cfe.set('sello', sello)
			else:
				self.cadena = self.sello = False
			#certfname = os.path.join(tools.config['root_path'], 'filestore/%s/%s'%(cr.dbname, inv_brw.company_id.certificate.store_fname))
                        certfname = inv_brw.company_id.ruta_certificado
			#verify = cfdutil.verifySello(cadena, certfname, sello)
			verify = cfdutil.verifySelloSHA1(self.cadena, certfname, self.sello)
			if not verify:
				raise osv.except_osv(('La llave privada no corresponde a la llave publica contenida en el certificado!'),("Favor de verificar !") )
			return cfe, cfe_tree


	def get_domicilio_fiscal(self, cr, uid, inv_brw, cfe_tree):
		partner_obj = self.pool.get('res.partner')
		address_obj = self.pool.get('res.partner')
		partner_brw = inv_brw.company_id.partner_id
		partner_id = inv_brw.company_id.partner_id.id
		address = etree.Element(cfe_tree+'Domicilio')
		#address_obj = self.pool.get('res.partner.address')
		address = etree.Element(cfe_tree+'DomicilioFiscal')
		invoice_address_id = partner_obj.address_get(cr, uid, [partner_id], ['invoice'])
		address_brw = address_obj.browse(cr, uid, invoice_address_id['invoice'])
		address.set('calle', self.make_utf(address_brw.street, 'Calle Emisior'))
                address_brw.addr_ext_number and address.set('noExterior', self.make_utf(address_brw.addr_ext_number, 'noExterior Emisor'))
                address_brw.addr_int_number and address.set('noInterior', self.make_utf(address_brw.addr_int_number, 'noInterior Emisor'))
		address_brw.street2 and address.set('colonia', self.make_utf(address_brw.street2))
                address.set('localidad', self.make_utf(address_brw.addr_location, 'Localidad Emisor'))
		address.set('municipio',self.make_utf(address_brw.city, 'Ciudad Emisor'))

		address.set('estado', self.make_utf(address_brw.state_id.name, 'Estado Emisor'))
		address.set('pais',self.make_utf(address_brw.country_id.name, 'Pais Emisor'))
		address.set('codigoPostal',self.make_utf(address_brw.zip,'Codigo Postal Emisor'))
                print address
		return address

	def get_domicilio_ubicacion(self, cr, uid, inv_brw, cfe_tree):
		partner_obj = self.pool.get('res.partner')
		address_obj = self.pool.get('res.partner')
		partner_id = inv_brw.partner_id.id
		address = etree.Element(cfe_tree+'Domicilio')
		#invoice_address_id = partner_obj.address_get(cr, uid, [partner_id], ['invoice'])
		invoice_address_id = inv_brw.partner_id.id
		#address_brw = address_obj.browse(cr, uid, invoice_address_id['invoice'])
		address_brw = address_obj.browse(cr, uid, invoice_address_id)
		address_brw.street and address.set('calle', self.make_utf(address_brw.street or ''))
                address_brw.addr_ext_number and address.set('noExterior', self.make_utf(address_brw.addr_ext_number or ''))
                address_brw.addr_int_number and address.set('noInterior', self.make_utf(address_brw.addr_int_number or ''))
		address_brw.street2 and address.set('colonia', self.make_utf(address_brw.street2 or ''))
                address_brw.addr_location   and address.set('localidad', self.make_utf(address_brw.addr_location or ''))
		address_brw.city and address.set('municipio',self.make_utf(address_brw.city or ''))
		address_brw.state_id and address.set('estado', self.make_utf(address_brw.state_id.name or ''))
		address_brw.country_id and address.set('pais',self.make_utf(address_brw.country_id.name or 'Pais Emisor'))
		address_brw.zip and address.set('codigoPostal',self.make_utf(address_brw.zip or ''))
		return address
	
	def get_emisor(self, cr, uid, inv_brw, cfe_tree):
		partner_brw = inv_brw.company_id.partner_id
		emisor = etree.Element(cfe_tree+'Emisor')
		emisor.append(self.get_domicilio_fiscal(cr, uid, inv_brw, cfe_tree))
		if self.VERSION_2012:
			for regimen in partner_brw.company_id.regimen_ids:
				if regimen.name:
					rr = etree.Element(cfe_tree+'RegimenFiscal')
					rr.set('Regimen', regimen.name)
					emisor.append(rr)
		if not partner_brw.vat:
			raise osv.except_osv(('No RFC Defined on Emisor Partner!'),("You must define a RFC for the company !") )
		emisor.set('rfc',re.sub('[-,._  \t\n\r\f\v]','',partner_brw.vat))
		emisor.set('nombre',self.make_utf(inv_brw.company_id.name, 'Emisor'))
		return emisor
	
	def get_receptor(self,cr, uid, inv_brw, cfe_tree):
		partner_brw = inv_brw.partner_id
		receptor = etree.Element(cfe_tree+'Receptor')
		receptor.append(self.get_domicilio_ubicacion(cr, uid, inv_brw, cfe_tree))
		if not partner_brw.vat:
			raise osv.except_osv(('No RFC Defined on Receptor Partner!'),("You must define a RFC for the Client !") )
		receptor.set('rfc',re.sub('[-,._  \t\n\r\f\v]','',partner_brw.vat))
		receptor.set('nombre',self.make_utf(inv_brw.partner_id.name or 'Empresa Receptora'))
		return receptor

	def get_conceptos(self, cr, uid, lines_brw_lst, cfe_tree):
		conceptos = etree.Element(cfe_tree+'Conceptos') 
		for line in lines_brw_lst:
			concept = etree.Element(cfe_tree+'Concepto')
			concept.set('cantidad', '%.2f'%(line.quantity))
			concept.set('descripcion',self.make_utf(line.name, 'Descripcion de Producto'))
			concept.set('valorUnitario','%.6f'%(line.price_unit * (1-line.discount/100)))
			concept.set('importe','%.6f'%(line.price_subtotal))
			uos = line.uos_id.name
			if uos:
				concept.set('unidad', uos)
			conceptos.append(concept)
		return conceptos



	def get_tax(self, cr, uid, tax, tax_type, tax_name, cfe_tree):
		retencion = etree.Element(cfe_tree+tax_name)
		if tax_type == 'retain_iva':
			retencion.set('impuesto','IVA')
		elif tax_type == 'retain_isr':
			retencion.set('impuesto','ISR')
		if tax_type == 'tax_ieps':
			retencion.set('impuesto','IEPS')
			tax_pct = round(float(tax.amount) / float(tax.base), 2)
			retencion.set('tasa', '%.2f'%(tax_pct * 100))
		elif tax_type == 'tax_iva':
			retencion.set('impuesto','IVA')
			tax_pct = round(float(tax.amount) / float(tax.base), 2)
			retencion.set('tasa', '%.2f'%(tax_pct * 100))
		retencion.set('importe', '%.2f'%(abs(tax.amount)))
		
		return retencion

	
	def get_impuestos(self, cr, uid, tax_line, cfe_tree=''):
		impuestos = etree.Element(cfe_tree+'Impuestos')
		traslados = etree.Element(cfe_tree+'Traslados')
		retenciones = etree.Element(cfe_tree+'Retenciones')
		total_retenciones = 0
		total_traslados = 0
		agrega_traslados = False
		agrega_retenciones = False
		for tax in tax_line:
                        print "tax.tax_code_id.tax_type: ", tax.tax_code_id.tax_type
			#tax_type = tax.tax_code_id.code
			tax_type = tax.tax_code_id.tax_type
			if (tax_type == 'tax_iva') or (tax_type == 'tax_ieps'):
				agrega_traslados = True
				traslados.append(self.get_tax(cr, uid, tax, tax_type, 'Traslado', cfe_tree ))
				total_traslados += tax.amount
			elif (tax_type == 'retain_iva') or (tax_type == 'retain_isr'):
				agrega_retenciones = True
				retenciones.append(self.get_tax(cr, uid, tax, tax_type, 'Retencion', cfe_tree))
				total_retenciones += tax.amount
		if agrega_traslados:
			impuestos.set('totalImpuestosTrasladados', '%.2f'%(abs(total_traslados)))
			impuestos.append(traslados)		
		if agrega_retenciones:
			impuestos.set('totalImpuestosRetenidos', '%.2f'%(abs(total_retenciones)))
			impuestos.append(retenciones)
		return impuestos



	def put_addenda(self,cr, uid, inv_brw, cfe, cfe_tree):
		partner_brw = inv_brw.partner_id
		if not partner_brw.addenda:
			#addenda = etree.SubElement(cfe, 'Addenda')
			return
		addenda_brw = partner_brw.addenda
		if addenda_brw.name == "Altos_Hornos":
			#NS='http://www.w3.org/2001/XMLSchema-instance'
			#schema_location = '{%s}schemaLocation' % NS
			AHMNS = 'http://www.ahmsa.com/xsd/AddendaAHM1'
			AHMURL = 'http://www.ahmsa.com/xsd/AddendaAHM1/AddendaAHM.xsd'
			AHMTREE = '{%s}' %(AHMNS, )
			AHMNSMAP = {'ahmsa': AHMNS}
			addenda = etree.SubElement(cfe, cfe_tree+'Addenda', nsmap=AHMNSMAP, attrib={self.schema_location: ' '.join([AHMNS, AHMURL])})
			ahmaddenda = etree.SubElement(addenda, AHMTREE+'AddendaAHM', nsmap=AHMNSMAP)
			ahmaddenda.set("Version", "1.0")
			ahmdoc = etree.SubElement(ahmaddenda, AHMTREE+"Documento")
			ahmdoc.set("Tipo", "1")
			ahmdoc.set("Clase", "HS")
			ahmenc = etree.SubElement(ahmdoc, AHMTREE+"Encabezado")
			ahmenc.set("NumSociedad", "S001")
			ahmenc.set("NumDivision", "")
			ahmenc.set("NumProveedor", "114436")
			ahmenc.set("Correo", "evr@incaconcretos.com")
			ahmenc.set("Moneda", "MXP")
			ahmdet = etree.SubElement(ahmdoc, AHMTREE+"Detalle")
			ahmped = etree.SubElement(ahmdet, AHMTREE+"Pedido")
			ahmped.set("Num", "4500934872")
			ahmhsr = etree.SubElement(ahmdet, AHMTREE+"HojaServicio")
			ahmhsr.set("Num", "1001821807")
			ahmtrn = etree.SubElement(ahmdet, AHMTREE+"Transporte")
			ahmtrn.set("Num", "")
			ahmctp = etree.SubElement(ahmdet, AHMTREE+"CtaxPag")
			ahmctp.set("Num", "")
			ahmctp.set("Ejercicio", "")
			ahmliq = etree.SubElement(ahmdet, AHMTREE+"Liquidacion")
			ahmliq.set("FechaInicio", "")
			ahmliq.set("FechaFin", "")
			open("/tmp/addenda.xml", "w").write(etree.tostring(cfe, pretty_print=True, encoding='utf-8', xml_declaration=True))
			return
		else:
			addenda = etree.SubElement(cfe, cfe_tree+'Addenda')
			return
		addenda_name = etree.Element(cfe_tree+addenda_brw.name)
		for line_brw in addenda_brw.line_ids:
			if  line_brw.default_value:
				value = line_brw.default_value
			else:
				value = self.make_utf(unicode(eval('inv_brw.' + line_brw.default)))
			addenda_line = etree.Element(cfe_tree+line_brw.tag)
			addenda_line.set(line_brw.tag,value)
			addenda_name.append(addenda_line)
		addenda.append(addenda_name)
		return addenda


	def get_discount(self, cr, uid, inv_brw):
		return 0

	def get_payment_form(self, cr, uid, inv_brw):
		return False

	
	def get_inv_number(self, cr, uid, inv_brw):
		prefix = inv_brw.journal_id.sequence_id.prefix or ''
		if (prefix) and (inv_brw.number):

			number = int(inv_brw.number[len(prefix):])
		else:
			number = int(inv_brw.number)
				
		return number, prefix


	def get_datos_comprobante_v3(self, cr, uid, inv_brw, cfe, context={} ):
		company_obj = self.pool.get('res.company.folios')
		if inv_brw.company_id.proveedor_cfd == 'my_suite_cfd':
			number = 0
			prefix = ''
		else:
			number, prefix = self.get_inv_number(cr, uid, inv_brw)
		if prefix:
			cfe.set('serie',prefix)
			#except:
			#	raise osv.except_osv(_('Error'), _("Couldn't create move between different companies"))
			#raise osv.except_osv(_('Error !'),_('The invoice number has to be an integer. Wrong configuratin, check your secuenceses.'))
		cfe.set('folio',str(int(number)))
		if context.has_key('date'):
			if context['date'].find('T') < 0:
				raise osv.except_osv(_('Error'), _("Invalid date in context: %s" %(conext['date'])))
			cfe.set('fecha',context['date'])
		else:
			cfe.set('fecha',now().strftime('%Y-%m-%dT%H:%M:%S'))
		cfe.set('formaDePago','Pago en una sola exhibicion')###ahy que poner una forma de pago valida
		cfe.set('condicionesDePago',self.make_utf(inv_brw.payment_term.name, 'Condiciones de Pago'))
		if inv_brw.company_id.proveedor_cfd in ('propios_medios', 'my_suite_timbre', 'buzon_fiscal_timbre', 'tralix_timbre'):
			#anoAprobacion = company_obj.get_folio_info(cr, uid, inv_brw.company_id.id, number, 'approved_year', prefix )
			#noAprobacion = company_obj.get_folio_info(cr, uid, inv_brw.company_id.id, number, 'approved_number', prefix)
		#### El certificado
			#certfname = os.path.join(tools.config['root_path'], 'filestore/%s/%s'%(cr.dbname, inv_brw.company_id.certificate.store_fname))
			nocert = cfdutil.getNoSerie(inv_brw.company_id.ruta_certificado)
			certstr = cfdutil.getCertString(inv_brw.company_id.ruta_certificado)
			#nocert = cfdutil.getNoSerie(certfname)
			#certstr = cfdutil.getCertString(certfname)
		#else:
			#nocert = certstr = anoAprobacion = noAprobacion = False
			#cfe.set('anoAprobacion',anoAprobacion)
			#cfe.set('noAprobacion',noAprobacion)
			cfe.set('noCertificado', nocert)
			cfe.set('certificado', certstr)
		#cfe.set('noCertificado',inv_brw.company_id.certificate_no)
		cfe.set('subTotal','%.2f'%(inv_brw.amount_untaxed))
		cfe.set('total','%.2f'%(inv_brw.amount_total))
		if inv_brw.type == 'out_invoice':
			cfe.set('tipoDeComprobante','ingreso')
		elif  inv_brw.type == 'out_refund':
			cfe.set('tipoDeComprobante','egreso')
		elif inv_brw.company_id.partner_id.vat == inv_brw.partner_id.vat:
			cfe.set('tipoDeComprobante','traslado')
		discount = self.get_discount(cr, uid, inv_brw)
		#Optinal Stuff
		if discount:
			cfe.set('descuento',str(discount))
		if self.VERSION_2012:
			method = (inv_brw.pay_method and inv_brw.pay_method.name) or self.DEFAULT_PAY_METHOD
			cfe.set('metodoDePago', method)
			if inv_brw.pay_account:
				cfe.set('NumCtaPago', inv_brw.pay_account)
			ubic = self.get_domicilio_fiscal(cr, uid, inv_brw, self.V3TREE)
			lugar = ', '.join([ubic.get('municipio'), ubic.get('estado')])
			cfe.set('LugarExpedicion', lugar)
		else:
			payment_form = self.get_payment_form(cr, uid, inv_brw)
			if payment_form:
				cfe.set('metodoDePago', payment_form)
		return cfe

	def getLocalCadenaOriginal(self, cfe):
		return cfdutil.getCadenaOriginal(cfe)

	def get_datos_comprobante(self, cr, uid, inv_brw, cfe,context={} ):
		company_obj = self.pool.get('res.company.folios')
		if inv_brw.company_id.proveedor_cfd == 'my_suite_cfd':
			number = 0
			prefix = ''
		else:
			number, prefix = self.get_inv_number(cr, uid, inv_brw)
		if prefix:
			cfe.set('serie',prefix)
			#except:
			#	raise osv.except_osv(_('Error'), _("Couldn't create move between different companies"))
			#raise osv.except_osv(_('Error !'),_('The invoice number has to be an integer. Wrong configuratin, check your secuenceses.'))
		cfe.set('folio',str(int(number)))
		if context.has_key('date'):
			cfe.set('fecha',context['date'])
		else:
			cfe.set('fecha',now().strftime('%Y-%m-%dT%H:%M:%S'))
		cfe.set('formaDePago','Pago en una sola exhibicion')###ahy que poner una forma de pago valida
		cfe.set('condicionesDePago',self.make_utf(inv_brw.payment_term.name, 'Condiciones de Pago'))
		if inv_brw.company_id.proveedor_cfd in ('propios_medios', 'my_suite_timbre', 'buzon_fiscal_timbre', 'tralix_timbre'):
			anoAprobacion = company_obj.get_folio_info(cr, uid, inv_brw.company_id.id, number, 'approved_year', prefix )
			noAprobacion = company_obj.get_folio_info(cr, uid, inv_brw.company_id.id, number, 'approved_number', prefix)
		#### El certificado
			#certfname = os.path.join(tools.config['root_path'], 'filestore/%s/%s'%(cr.dbname, inv_brw.company_id.certificate.store_fname))
			nocert = cfdutil.getNoSerie(inv_brw.company_id.ruta_certificado)
			certstr = cfdutil.getCertString(inv_brw.company_id.ruta_certificado)
		#else:
			#nocert = certstr = anoAprobacion = noAprobacion = False
			cfe.set('anoAprobacion',anoAprobacion)
			cfe.set('noAprobacion',noAprobacion)
			cfe.set('noCertificado', nocert)
			cfe.set('certificado', certstr)
		#cfe.set('noCertificado',inv_brw.company_id.certificate_no)
		cfe.set('subTotal','%.2f'%(inv_brw.amount_untaxed))
		cfe.set('total','%.2f'%(inv_brw.amount_total))
		if inv_brw.type == 'out_invoice':
			cfe.set('tipoDeComprobante','ingreso')
		elif  inv_brw.type == 'out_refund':
			cfe.set('tipoDeComprobante','egreso')
		elif inv_brw.company_id.partner_id.vat == inv_brw.partner_id.vat:
			cfe.set('tipoDeComprobante','traslado')
		discount = self.get_discount(cr, uid, inv_brw)
		#Optinal Stuff
		if discount:
			cfe.set('descuento',str(discount))
		if self.VERSION_2012:
			method = (inv_brw.pay_method and inv_brw.pay_method.name) or self.DEFAULT_PAY_METHOD
			cfe.set('metodoDePago', method)
			if inv_brw.pay_account:
				cfe.set('NumCtaPago', inv_brw.pay_account)
			ubic = self.get_domicilio_fiscal(cr, uid, inv_brw, self.V2TREE)
			lugar = ', '.join([ubic.get('municipio'), ubic.get('estado')])
			cfe.set('LugarExpedicion', lugar)
		else:
			payment_form = self.get_payment_form(cr, uid, inv_brw)
			if payment_form:
				cfe.set('metodoDePago', payment_form)
		return cfe



	#
	#MY SUITE
	#\

	def compute_tax_by_line(self, cr, uid, invoice_id, context={}):
		tax_grouped = {}
		tax_obj = self.pool.get('account.tax')
		cur_obj = self.pool.get('res.currency')
		inv = self.pool.get('account.invoice').browse(cr, uid, invoice_id, context)
		cur = inv.currency_id
		company_currency = inv.company_id.currency_id.id
		res = {}
		line_num = 0
		for line in inv.invoice_line:
		    count = 0
		    res[line_num] = []
		    gg = tax_obj.compute(cr, uid, line.invoice_line_tax_id, (line.price_unit* (1-(line.discount or 0.0)/100.0)), line.quantity, inv.partner_id.id, line.product_id, inv.partner_id)
		    for tax in tax_obj.compute(cr, uid, line.invoice_line_tax_id, (line.price_unit* (1-(line.discount or 0.0)/100.0)), line.quantity, inv.partner_id.id, line.product_id, inv.partner_id):
			val={}
			val['invoice_line_id'] = line.id
			val['codigo_int'] = line.invoice_line_tax_id[count].description
			val['codigo_int'] = line.invoice_line_tax_id[count].tax_code_id.code
			val['tasa'] = str(abs(line.invoice_line_tax_id[count].amount)*100)
			val['contexto'] = 'FEDERAL'
			val['amount'] = tax['amount']
			val['base'] = tax['price_unit'] * line['quantity']
			if val['codigo_int'] in ('tax_ieps','tax_iva'):
				val['operacion'] = 'TRASLADO'
			elif val['codigo_int'] in ('retain_iva','retain_isr'):
				val['operacion'] = 'RETENCION'
			if val['codigo_int'] in ('retain_iva','tax_iva'):
				val['codigo'] = 'IVA'
			elif val['codigo_int'] in ('tax_ieps',):
				val['codigo'] = 'IEPS'
			elif val['codigo_int'] in ('retain_isr',):
				val['codigo'] = 'ISR'
			if inv.type in ('out_invoice','in_invoice'):
				val['base_amount'] = '%.2f'%(abs(cur_obj.compute(cr, uid, inv.currency_id.id, company_currency, val['base'] * tax['base_sign'], context={'date': inv.date_invoice or time.strftime('%Y-%m-%d')}, round=False)))
				val['tax_amount'] = '%.2f'%(abs(cur_obj.compute(cr, uid, inv.currency_id.id, company_currency, val['amount'] * tax['tax_sign'], context={'date': inv.date_invoice or time.strftime('%Y-%m-%d')}, round=False)))
			else:
			    val['base_amount'] = '%.2f'%(abs(cur_obj.compute(cr, uid, inv.currency_id.id, company_currency, val['base'] * tax['ref_base_sign'], context={'date': inv.date_invoice or time.strftime('%Y-%m-%d')}, round=False)))
			    val['tax_amount'] = '%.2f'%(abs(cur_obj.compute(cr, uid, inv.currency_id.id, company_currency, val['amount'] * tax['ref_tax_sign'], context={'date': inv.date_invoice or time.strftime('%Y-%m-%d')}, round=False)))
			count += 1
			res[line_num].append(val)
		    line_num += 1
		return res


account_invoice()


class account_invoice_xsd_types(osv.osv):
	_name = "account.invoice.xsd.types"
	columns = {
		'name': fields.char('Type name', size=64, required=True),
		'namespace': fields.char('Namespace', size=256, required=True),
		'children_elements': fields.one2many('account.invoice.xsd.element', 'parent_type_id', 'Children elements'),
		'parent_type': fields.many2one('account.invoice.xsd.types', 'Parent type'),
		'attributes': fields.one2many('account.invoice.xsd.attributes', 'type_id', 'Attributes')
	}

account_invoice_xsd_types()

class account_invoice_xsd_attributes(osv.osv):
	_name = "account.invoice.xsd.attributes"
	_columns = {
		'name': fields.char('Attribute Name', size=64, required=True),
		'required': fields.boolean('Required'),
		'type_id': fields.many2one('account.invoice.xsd.types', 'Type'),
		'self_type_id': fields.many2one('account.invoice.xsd.types', 'My type'),
		'documentation': fields.text("Documentation")
	}

account_invoice_xsd_attributes()

class account_invoice_xsd_elements(osv.osv):
	_name = "account.invoice.xsd.elements"
	_columns = {
		'name': fields.char('Element Name', size=64, required=True),
		'namespace': fields.char('Namespace', size=256),
		'type': fields.many2one('account.invoice.xsd.types', 'Type', required=True),
		'documentation': fields.text("Documentation"),
		'minoccurs': fields.integer("minOccurs"),
		'maxoccurs': fields.integer("maxOccurs"),
		'prev_sibling': fields.many2one('account.invoice.xsd.elements', 'Initial element'),
		'next_sibling': fields.many2one('account.invoice.xsd.elements', 'Next element')
	}

account_invoice_xsd_elements()

class account_invoice_addenda(osv.osv):
    _name = "account.invoice.addenda"
    _description = "Addenda for the Electronic Invoice"

    def loadNamespaces(self, elem, nsdir):
	    nsdir.update(elem.nsmap)
	    for item in elem.iterchildren():
		    nsdir.update(self.loadNamespaces(item, nsdir))
	    return nsdir

    def getSequence(self, cr, uid, elem, nsdir, ns):
	    for item in elem.iterchildren():
		    if item.tag.endswith("sequence"):
			    print "processing sequence", [(x.attrib.has_key('name') and x.attrib['name']) or x.tag for x in item.iterchildren()]
			    for subitem in item.iterchildren():
				    if subitem.attrib.has_key('name') or x.tag.endswith("any"):
					    self.getElement(cr, uid, subitem, nsdir, ns)
				    elif subitem.attrib.has_key('ref'):
					    print "!!!!!!!!!!!!!!! 'ref' ATTRIBUTE NOT YET IMPLEMENTED !!!!!!!!!!!!!!!!!!"
			    break
	    else:
		    print "No sequence found in element %s, name: %s" %(elem.getparent().tag, elem.getparent().attrib['name'])
		    

    def getAttributes(self, cr, uid, elem, nsdir, ns):
	    attriblist = []
	    for item in elem.iterchildren():
		    mydir = {}
		    if item.tag.endswith("attribute"):
			    myname = item.attrib['name']
			    if (myname.find('{') == 0) and (myname.find('}') > 1):
				    mydir['name'] = myname.split('}')[1]
				    mydir['ns'] = myname[1:myname.find('}')]
			    elif myname.find(':') > 0:
				    mydir['ns'] = nsdir[item.tag.split(':')[0]]
				    mydir['name'] = item.tag.split(':')[1]
			    else:
				    mydir['name'] = myname
				    mydir['ns'] = ns
			    if item.attrib.has_key('type'):
				    mytype = item.attrib['type']
				    if mytype.find(':') > 0:
					    typens, typename = mytype.split(':')
				    else:
					    typens = ns
					    typename = mytype
				    mydir['typens'] = typens
				    mydir['typename'] = typename
			    else:
				    mydir['typens'] = False
				    mydir['typename'] = False

			    if item.attrib.has_key('use') and item.attrib['use'] == 'required':
				    mydir['required'] = True
			    else:
				    mydir['required'] = False
			    attriblist.append(mydir)
	    return attriblist

    def getElemType(self, cr, uid, elem, nsdir, ns):
	    if elem.tag.endswith("any"):
		    if (elem.tag.find('{') == 0) and (elem.tag.find('}') > 0):
			    myns = elem.tag[1:elem.tag.find('}')]
		    else:
			    myns = ns
		    myname = "any"
		    elemseq = []
		    attriblist = []
	    elif elem.attrib.has_key('type'):
		    typeelem = elem
		    typeval = elem.attrib['type']
		    if typeval.find(':') > 0:
			    myns = nsdir[typeval.split(':')[0]]
			    myname = typeval.split(':')[1]
		    else:
			    myns = ns
			    myname = typeval
		    print "Using previous type. %s:%s" %(myns, myname)
		    attriblist = self.getAttributes(cr, uid, typeelem, nsdir, ns)
	    else:
		    for item in elem.iterchildren():
			    if item.tag.endswith("complexType"):
				    typeelem = item
				    myns = ns
				    myname = elem.attrib['name']
				    break
			    elif item.tag.endswith("simpleType"):
				    for subitem in item.iterchildren():
					    if subitem.tag.endswith("restriction"):
						    typeelem = False
						    typeval = subitem.attrib["base"]
						    if typeval.find(':') > 0:
							    myns = nsdir[typeval.split(':')[0]]
							    myname = typeval.split(':')[1]
						    else:
							    myns = ns
							    myname = typeval
						    break
				    else:
					    raise osv.except_osv(('Error in XML'), ('Unable to find type of element %s.'%(etree.tostring(item), )))
				    break
		    else:
			    print "No type in element", (elem.attrib.has_key('name') and elem.attrib['name']) or etree.tostring(elem)
			    typeelem = False
			    #raise osv.except_osv(('Error in XML'), ('Unable to find type of element %s, name: %s ' %(elem.tag, elem.attrib['name'])))
		    if not 'name' in elem.attrib.keys():
			    raise osv.except_osv(('Error in XML'), ('No name attribute in "element" tag.'))
		    if typeelem != False:
			    print "Creating complex type. %s:%s" %(myns, myname)
			    elemseq = self.getSequence(cr, uid, typeelem, nsdir, ns)
			    attriblist = self.getAttributes(cr, uid, typeelem, nsdir, ns)
		    else:
			    elemseq = []
			    attriblist = []
	    if len(attriblist):
		    print "Attributes in  type {%s}%s : %s" %(myns, myname, [x['name'] for x in attriblist])
	    #myid = self.pool.get('account.invoice.xsd.types').create(cr, uid, {'name': myname, 'namespace': myns})

    def getSimpleContent(self, cr, uid, elem, nsdir, ns):
	    for item in elem.iterchildren():
		    if item.tag.endswith('simpleContent'):
			    for subitem in item.iterchildren():
				    if subitem.tag.endswith('extension'):
					    nameval = subitem.attrib['base']
					    if nameval.find(':') > 0:
						    myns = nsdir[nameval.split(':')[0]]
						    myname = nameval.split(':')[1]
					    else:
						    myns = ns
						    myname = nameval
					    break
			    else:
				    raise osv.except_osv(('Error in XML'), ('No name extension element %s' %(etree.tostring(elem), )))
	    return myns, myname

    def getComplexType(self, cr, uid, elem, nsdir, ns):
	    if not elem.attrib.has_key('name'):
		    raise osv.except_osv(('Error in XML'), ('No name attribute in element %s' %(etree.tostring(elem), )))
	    nameval = elem .attrib['name']
	    if nameval.find(':') > 0:
		    myns = nsdir[nameval.split(':')[0]]
		    myname = nameval.split(':')[1]
	    else:
		    myns = ns
		    myname = nameval
	    if True in [x.tag.endswith('sequence') for x in elem.iterchildren()]:
		    elemseq = self.getSequence(cr, uid, elem, nsdir, ns)
	    elif True in [x.tag.endswith('simpleContent') for x in elem.iterchildren()]:
		    myns, myname = self.getSimpleContent(cr, uid, elem, nsdir, ns)
	    attriblist = self.getAttributes(cr, uid, elem, nsdir, ns)
	    print "Attributes in  type {%s}%s : %s" %(myns, myname, [x['name'] for x in attriblist])
	    return myns, myname

    def getElement(self, cr, uid, elem, nsdir, ns):
	    if elem.tag.endswith("element"):
		    mytype = self.getElemType(cr, uid, elem, nsdir, ns)
		    print "Adding element %s" %(elem.attrib['name'], )
	    elif elem.tag.endswith("any"):
		    
		    print "NOT PROCESSING %s: %s" %(elem.tag, etree.tostring(elem))

    def getSimpleType(self, cr, uid, elem, nsdir, ns):
	    if not elem.attrib.has_key('name'):
		    raise osv.except_osv(('Error in XML'), ('No name attribute in element %s' %(etree.tostring(elem), )))
	    nameval = elem .attrib['name']
	    if nameval.find(':') > 0:
		    myns = nsdir[nameval.split(':')[0]]
		    myname = nameval.split(':')[1]
	    else:
		    myns = ns
		    myname = nameval
	    for item in elem.iterchildren():
		    if item.tag.endswith("restriction"):
			    typeval = item.attrib["base"]
			    if typeval.find(':') > 0:
				    basens = nsdir[typeval.split(':')[0]]
				    basename = typeval.split(':')[1]
			    else:
				    basens = ns
				    basename = typeval
			    break
	    else:
		    raise osv.except_osv(('Error in XML'), ('Unable to find type of element %s.'%(etree.tostring(elem), )))
	    return myns, myname, basens, basename


    def populateAddenda(self, cr, uid, rootelem, nsdir, ns):
	    typelist = []
	    elemlist = []
 	    for elem in rootelem.iterchildren():
		    if isinstance(elem.tag, str):
			    if elem.tag.endswith('simpleType'):
				    mytypens, mytypename, basetypens, basetypename = self.getSimpleType(cr, uid, elem, nsdir, ns)
				    print "Simple type: {%s}%s (base: {%s}%s)" %(mytypens, mytypename, basetypens, basetypename)
		    elif not('__name__' in dir(elem.tag)) or elem.tag.__name__ != "Comment":
			    raise osv.except_osv(('Error in XML'), ('Unknown element: %s' %(etree.tostring(elem, pretty_print=True), )))
 	    for elem in rootelem.iterchildren():
		    if isinstance(elem.tag, str):
			    if elem.tag.endswith('complexType'):
				    mytypens, mytypename = self.getComplexType(cr, uid, elem, nsdir, ns)
				    print "Complex type: {%s}%s" %(mytypens, mytypename)
		    elif not('__name__' in dir(elem.tag)) or elem.tag.__name__ != "Comment":
			    raise osv.except_osv(('Error in XML'), ('Unknown element: %s' %(etree.tostring(elem, pretty_print=True), )))
	    for elem in rootelem.iterchildren():
		    if isinstance(elem.tag, str):
			    if elem.tag.endswith('element'):
				    myelem = self.getElement(cr, uid, elem, nsdir, ns)
		    elif not('__name__' in dir(elem.tag)) or elem.tag.__name__ != "Comment":
			    raise osv.except_osv(('Error in XML'), ('Unknown element: %s' %(etree.tostring(elem, pretty_print=True), )))
	    return elemlist


    def loadAddenda(self, cr, uid, uri, name, note=""):
	    try:
		    xmldata = urllib2.urlopen(uri).read()
		    xsd = etree.parse(StringIO.StringIO(xmldata))
	    except Exception, msg:
		    raise osv.except_osv(('Error reading uri: %s!' %(uri, )),("Error message: %s" %(msg, )) )
	    xsdroot = xsd.getroot()
	    if not xsdroot.tag.endswith("schema"):
		    raise osv.except_osv(('Error in XML Schema'), ('Root element must be "schema".'))
	    ns = xsdroot.get("targetNamespace")
	    nsdir = self.loadNamespaces(xsdroot, {})
	    elemlist = self.populateAddenda(cr, uid, xsdroot, nsdir, ns)
	    return True


    _columns = {
        'name': fields.char('Addenda', size=64, required=True),
	'xmldata': fields.text('XML'),
        'active': fields.boolean('Active'),
        'note': fields.text('Description', translate=True),
	'root_element': fields.many2one('account.invoice.xsd.elements', 'Root Element'),
        'line_ids': fields.one2many('account.invoice.addenda.lines', 'addenda_id', 'Terms')
    }
    _defaults = {
        'active': lambda *a: 1,
    }
    _order = "name"


account_invoice_addenda()

class account_invoice_addenda_lines(osv.osv):
    _name = "account.invoice.addenda.lines"
    _description = "Lines of the Electronic Invoice Addenda"

    def _col_get(self, cr, user, context={}):
        result = []
        cols = self.pool.get('account.invoice')._columns
        for col in cols:
            result.append( (col, cols[col].string) )
        result.sort()
        return result

    
    _columns = {
	    'name': fields.char('Field Name', size=64, required=True),
	    'tag': fields.char('Tag', size=64, required=True),
	    'sequence': fields.integer('Sequence', required=True, help="The sequence field is used to order fields"),
	    'required': fields.boolean('Required'),
	    'relation': fields.many2one('ir.model', 'Relation'),
	    'default': fields.char('Default id', size=64),
	    'default_value': fields.char('Default Value', size=64),
	    'field': fields.selection(_col_get, 'Field Name', method=True, size=64),
	    'addenda_id': fields.many2one('account.invoice.addenda', 'Addenda', required=True, select=True),

	    }
    _defaults = {
        'sequence': lambda *a: 5,

    }
    _order = "sequence"

account_invoice_addenda_lines()







