##############################################################################
#
# Copyright (c) 2005-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import pooler
#import wizard
import base64
from osv import fields, osv
from tools.translate import _
import time
import mx.DateTime
from mx.DateTime import RelativeDateTime, now, DateTime, localtime
import datetime
import re
import StringIO
import csv
from lxml import etree
from tools.misc import UpdateableStr

def last_day_of_month(date):
    print "date: ", date
    if date.month == 12:
        return date.replace(day=31)
    return date.replace(month=date.month+1, day=1) - datetime.timedelta(days=1)    


class account_invoice_electronic_report(osv.osv_memory):
    _name = 'account.invoice.electronic.report'

    _columns = {
            'company_id'    : fields.many2one('res.company', 'Company'),
            'fiscalyear_id' : fields.many2one('account.fiscalyear', 'Periodo Fiscal'),
            'period_id'     : fields.many2one('account.period', 'Mes'),
            'file_name'     : fields.binary('Export File', readonly=True),
            'final_state'   : fields.boolean('Final'),
            'log'           : fields.text('Log'),
            }
    
    _defaults = {
            'company_id'   : lambda self,cr,uid,c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
            }

    def get_report(self, cr, uid, ids, context):
        for rec in self.browse(cr, uid, ids):
            agnio = int(rec.fiscalyear_id.date_start[:4])
            mes = int(rec.period_id.date_start[5:7])
            rfc = rec.company_id.partner_id.vat
        rfc = re.sub('-','',rfc)

        res = file = self._reporte(cr, uid, rfc, mes, agnio)
        report_name = str('1%s%s%s.txt'%(rfc, mes, agnio))
        print report_name
        buf=StringIO.StringIO()
        writer=buf.write(res)
        out=base64.encodestring(buf.getvalue())
        buf.close()
        context['default_final_state'] = True
        context['default_file_name'] = out
        context['default_log'] = res
        return {
            'name'      : _('Export Electronic Invoice Reporte'),
            'view_type' : 'form',
            'view_mode' : 'form',
            'res_model' : 'account.invoice.electronic.report',
            'context'   : context,
            'type'      : 'ir.actions.act_window',
            'target'    : 'new',
            }



    def _reporte(self, cr, uid, rfc, mes, agnio):
        import datetime
        report_name = str('1%s%s%s.txt'%(rfc, mes, agnio))
        result = ""
        ### Obtenemos una lista de las facturas
        date_from = "%s-%s-01 00:00:00"%(agnio, mes)
        date_to = last_day_of_month(datetime.date(agnio, mes, 1)).strftime('%Y-%m-%d 24:00:00')
        attach_obj = self.pool.get('ir.attachment')
        journal_obj =  self.pool.get('account.journal')
        journal_idlist = journal_obj.search(cr, uid, [('e_invoice', '=', True)])
        invoice_obj =  self.pool.get('account.invoice')
        accountmove_obj =  self.pool.get('account.move')
        invoice_idlist = invoice_obj.search(cr, uid, [('journal_id', 'in', journal_idlist),
                                                      ('sign_date', '>=', date_from),
                                                      ('sign_date', '<=', date_to),
                                                      ('state', '!=', 'draft'),
                                                      ('state', '!=', 'proforma'),
                                                      ('state', '!=', 'proforma2')])
        cancelled_idlist = invoice_obj.search(cr, uid, [('journal_id', 'in', journal_idlist),
                                                        ('cancel_date', '>=', date_from),
                                                        ('cancel_date', '<=', date_to)])
        ## Para cada factura:
        for cancelled, inv_brw in [(False, x) for x in invoice_obj.browse(cr, uid, invoice_idlist)] + [(True, x) for x in invoice_obj.browse(cr, uid, cancelled_idlist)]:
            ##  Obtenemos el xml
            attach_id = attach_obj.search(cr, uid, [('res_model', '=', 'account.invoice'),('res_id', '=', inv_brw.id),('name', 'not ilike', '%old'),('datas_fname', 'ilike', '%.xml')])
            print "attach_id: ", attach_id
            if not(len(attach_id) and attach_id[0]):
                result += '-------- NO HAY ARCHIVO XML DEL FOLIO %s -----------\n' %(inv_brw.number, )
                bindata = False
                continue
            else:
                bindata = attach_obj.browse(cr, uid, attach_id)[0].datas
                xmldata = base64.decodestring(bindata)

            ### Obtener subtotal
            move_id = inv_brw.move_id.id
            invoice_line_list = inv_brw.invoice_line
            acc_list = []
            for invoice_line_brw in invoice_line_list:
                acct_id = invoice_line_brw.account_id.id
                if not (acct_id in acc_list):
                    acc_list.append(acct_id)
            invoice_type = invoice_obj.read (cr, uid, inv_brw.id, ['type'])['type']
            if invoice_type == 'out_invoice':
                credit_debit = 'credit'
                collected_paid = 'account_collected_id'
            elif invoice_type == 'out_refund':
                credit_debit = 'debit'
                collected_paid = 'account_paid_id'
            else:
                print " TIPO DESCONOCIDO DE FACTURA"
                raise osv.except_osv(('Error !'), ('la factura numero %s es de tipo desconocido: %s.'%(inv_brw.number, invoice_type)))
            
            subtotal = 0.0
            impuestos_tra = 0.0
            impuestos_ret = 0.0
            for journal_entry_brw in accountmove_obj.browse(cr, uid, move_id).line_id:
                if journal_entry_brw.account_id.id in acc_list:
                    if invoice_type =='out_invoice':
                        subtotal += journal_entry_brw.credit
                        subtotal -= journal_entry_brw.debit
                    else:
                        subtotal -= journal_entry_brw.credit
                        subtotal += journal_entry_brw.debit
                elif journal_entry_brw.tax_code_id:
                    tax_code_id = journal_entry_brw.tax_code_id.id
                    tax_type = self.pool.get('account.tax.code').browse(cr, uid, tax_code_id).tax_type
                    if tax_type in ['tax_iva', 'tax_ietu', 'retain_iva', 'retain_ietu']:
                        if invoice_type =='out_invoice':
                            impuestos_tra += journal_entry_brw.credit
                            impuestos_ret += journal_entry_brw.debit
                        else:
                            impuestos_ret += journal_entry_brw.credit
                            impuestos_tra += journal_entry_brw.debit 
            total_str = "%.02f" %(subtotal + impuestos_tra - impuestos_ret, )
            tax_str = "%.02f" %(impuestos_tra, )
            linea = self.pool.get('account.invoice').cfdutil_getLineaReporte(etree.parse(StringIO.StringIO(xmldata)), cancelled, tax_str, total_str)
            result += linea + "\n"
        return result[:-1]


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
